package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.dto.MusicGroupRegRespDto;
import com.ym.mec.biz.dal.dto.MusicGroupSubjectGoodsAndInfoDto;
import com.ym.mec.biz.dal.entity.MusicGroupSubjectPlan;
import com.ym.mec.common.service.BaseService;

import java.util.List;

public interface MusicGroupSubjectPlanService extends BaseService<Integer, MusicGroupSubjectPlan> {

    /**
     * 获取乐团声部招生计划
     *
     * @param musicGroupId
     * @return
     */
    List<MusicGroupSubjectPlan> getMusicSubjectClassPlan(int musicGroupId);


    /**
     * 获取单一乐团声部招生计划
     *
     * @param musicGroupId
     * @return
     */
    MusicGroupSubjectPlan getMusicOneSubjectClassPlan(int musicGroupId, int subjectId);

    /**
     * 获取乐团声部报名缴费商品信息
     *
     * @param musicGroupId
     * @param subjectId
     * @return
     */
    MusicGroupSubjectGoodsAndInfoDto getSubjectGoodsAndInfo(Integer musicGroupId, Integer subjectId);

    /**
     * 乐团报名基本信息
     * @param musicGroupId
     * @return
     */
    MusicGroupRegRespDto getMusicGroupRegInfo(Integer musicGroupId);

}