package com.ym.mec.education.controller;

import com.ym.mec.education.base.BaseResponse;
import com.ym.mec.education.base.PageResponse;
import com.ym.mec.education.enums.ReturnCodeEnum;
import com.ym.mec.education.req.ClassGroupReq;
import com.ym.mec.education.req.CourseScheduleReq;
import com.ym.mec.education.resp.CourseScheduleResp;
import com.ym.mec.education.service.ICourseScheduleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.util.Objects;

/**
 * @program: mec
 * @description: 课表
 * @author: xw
 * @create: 2019-09-26 21:04
 */
@RestController
@RequestMapping("api/courseSchedule")
@Api(tags = "课表")
@Slf4j
public class CourseScheduleController {

    @Autowired
    private ICourseScheduleService courseScheduleService;

    @PostMapping("/list")
    @ApiOperation("课表列表")
    public PageResponse list(@RequestBody @Validated ClassGroupReq classGroupReq) {
        return courseScheduleService.getPage(classGroupReq);
    }

    @PostMapping("/info")
    @ApiOperation("点名详情-头信息")
    public BaseResponse<CourseScheduleResp> getInfo(@RequestBody CourseScheduleReq courseScheduleReq) {
        return courseScheduleService.getInfo(courseScheduleReq);
    }

    @PostMapping("/statisticsInfo")
    @ApiOperation("历史考勤统计-头信息")
    public BaseResponse getStatisticsInfo(@RequestBody CourseScheduleReq courseScheduleReq) {
        return courseScheduleService.getStatisticsInfo(courseScheduleReq);
    }
}
