package com.ym.mec.teacher.controller;

import com.ym.mec.biz.dal.dto.DemoGroupApplyDto;
import com.ym.mec.biz.service.DemoGroupService;
import com.ym.mec.common.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Author Joburgess
 * @Date 2019/9/25
 */
@Api(tags = "试听课")
@RequestMapping("demoGroup")
@RestController
public class DemoGroupController extends BaseController {

    @Autowired
    private DemoGroupService demoGroupService;

    @ApiOperation(value = "试听课申请")
    @PostMapping("/demoGroupApply")
    public Object demoGroupApply(@RequestBody DemoGroupApplyDto demoGroup){
        demoGroupService.demoGroupApply(demoGroup);
        return succeed();
    }

    @ApiOperation(value = "获取试听课")
    @GetMapping("/getDemoGroupByTeacherId")
    public Object getDemoGroupByTeacherId(){
        return succeed(demoGroupService.getDemoGroupByTeacherId());
    }

}
