package com.ym.mec.thirdparty.message.provider;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.nacos.common.util.Md5Utils;
import com.ym.mec.thirdparty.message.MessageSenderPlugin;
import com.ym.mec.util.date.DateUtil;
import com.ym.mec.util.encode.AES;
import com.ym.mec.util.http.HttpUtil;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.codec.digest.Md5Crypt;
import org.apache.commons.lang3.StringUtils;
import org.apache.tomcat.util.security.MD5Encoder;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import sun.security.provider.MD5;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

/**
 * 极光推送
 */
@Service
public class YimeiSmsPlugin implements MessageSenderPlugin, InitializingBean {
	@Value("${com.properties.sms-appId:EUCP-EMY-SMS1-1AIHP}")
	private String appId;
	@Value("${com.properties.sms-secretKey:CBA790799C876DAD}")
	private String secretKey;
	@Value("${com.properties.sms-host-dev:http://bjksmtn.b2m.cn}")
	private String host;
	// 加密算法
	private static String algorithm = "AES/ECB/PKCS5Padding";
	// 是否压缩
	static boolean isGizp = false;

	public static String getName() {
		return "yimei";
	}

	private String getParam(String subject, String content, String receiver,String host){
		try {
			HashMap<String,Object> param = new HashMap();
			param.put("appId","");
			String timestamp = DateUtil.format(new Date(),new SimpleDateFormat("yyyyMMddHHmmss"));
			param.put("timestamp", timestamp);
			param.put("sign", DigestUtils.md5Hex(appId + secretKey + timestamp));
			param.put("content",receiver);
			param.put("mobiles",subject);
			return HttpUtil.postForHttp(host, param);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "";
	}

	@Override
	public boolean send(String subject, String content, String receiver, String url) throws Exception {
		String result = getParam(subject, content, receiver, host + "/simpleinter/sendSMS");
		JSONObject json = JSONObject.parseObject(result);
		if("SUCCESS".equals(json.get("code"))){
			return true;
		}else {
			throw new Exception(json.getString("code"));
		}
	}

	@Override
	public boolean batchSend(String subject, String content, String[] receivers, String url) throws Exception {
		String join = StringUtils.join(receivers, ",");
		String result = getParam(subject, content, join, host + "/simpleinter/sendSMS");
		JSONObject json = JSONObject.parseObject(result);
		if("SUCCESS".equals(json.get("code"))){
			return true;
		}else {
			throw new Exception(json.getString("code"));
		}
	}

	@Override
	public void afterPropertiesSet() throws Exception {

	}
}
