package com.ym.mec.web.controller;

import com.ym.mec.auth.api.client.SysUserFeignService;
import com.ym.mec.auth.api.entity.SysUser;
import com.ym.mec.biz.dal.entity.SysUserBankCard;
import com.ym.mec.biz.service.SysUserBankCardService;
import com.ym.mec.common.controller.BaseController;
import com.ym.mec.common.page.QueryInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

@RequestMapping("userBankCard")
@Api(tags = "银行卡信息服务")
@RestController
public class SysUserBankCardController extends BaseController {

    @Autowired
    private SysUserBankCardService sysUserBankCardService;
    @Autowired
    private SysUserFeignService sysUserFeignService;

    @ApiOperation(value = "新增银行卡信息")
    @PostMapping("/add")
    public Object add(SysUserBankCard sysUserBankCard) {
        if(sysUserBankCard == null){
            return failed("参数校验异常");
        }
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if(sysUser == null || sysUser.getId() == null){
            return failed("获取用户失败");
        }
        sysUserBankCard.setUserId(sysUser.getId());
        return succeed(sysUserBankCardService.add(sysUserBankCard));
    }

    @ApiOperation(value = "删除银行卡信息")
    @PostMapping("/del")
    public Object del(Long id) {
        sysUserBankCardService.delete(id);
        return succeed();
    }

    /*@ApiOperation(value = "修改银行卡信息")
    @PostMapping("/update")
    public Object update(SysUserBankCard sysUserBankCard) {
        sysUserBankCard.setModifyOn(new Date());
        sysUserBankCardService.update(sysUserBankCard);
        return succeed();
    }*/

    @ApiOperation(value = "分页查询银行卡信息列表")
    @GetMapping("/queryPage")
    public Object queryPage(String search) {
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if(sysUser == null || sysUser.getId() == null){
            return failed("获取用户失败");
        }
        return succeed(sysUserBankCardService.findByUser(search,sysUser.getId()));
    }
}
